import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class CorralEntity extends Equatable {
  final String uuid;
  final String nombre;
  final String mixerUuid;
  final bool activo;

  CorralEntity(this.uuid, this.nombre,  this.mixerUuid ,this.activo);

  Map<String, Object> toJson() {
    return {
      'nombre': this.nombre,
      'mixer': this.mixerUuid,
      'activo': this.activo,
    };
  }

  @override
  String toString() {
    return 'CorralEntity{uuid: $uuid, nombre: $nombre, mixerUuid: $mixerUuid, activo: $activo}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CorralEntity &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          nombre == other.nombre &&
          mixerUuid == other.mixerUuid &&
          activo == other.activo;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      nombre.hashCode ^
      mixerUuid.hashCode ^
      activo.hashCode;

  static CorralEntity fromJson(Map<String, Object> json) {
    return CorralEntity(json["uuid"] as String, json["nombre"] as String,
        json["mixer"] as String, json["activo"] as bool);
  }

  CorralEntity.fromSnapshot(DocumentSnapshot snapshot)
      : uuid = snapshot.documentID,
        nombre = snapshot.data['nombre'],
        mixerUuid = snapshot.data['mixer'],
        activo = snapshot.data['activo'];

  Map<String, Object> toDocument() {
    return {
      "nombre": nombre,
      "mixer": mixerUuid,
      "activo": activo,
    };
  }
}
