

import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class TratamientoProgramadoEntity extends Equatable{
  final String uuid;
  final List<dynamic> detalle;
  final DateTime fecha;
  final bool pendiente;
  final String tropaUuid;

  TratamientoProgramadoEntity(this.uuid, this.detalle, this.fecha, this.pendiente, this.tropaUuid);

  Map<String, Object> toJson(){
    return {
      'detalle': this.detalle,
      'fecha': this.fecha,
      'pendiente': this.pendiente,
      'tropaUuid': this.tropaUuid
    };
  }

  @override
  String toString() {
    return 'TratamientoProgramadoEntity{uuid: $uuid, detalle: $detalle, fecha: $fecha, pendiente: $pendiente, tropaUuid: $tropaUuid}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is TratamientoProgramadoEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              detalle == other.detalle &&
              fecha == other.fecha &&
              pendiente == other.pendiente &&
              tropaUuid == other.tropaUuid;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      detalle.hashCode ^
      fecha.hashCode ^
      pendiente.hashCode ^
      tropaUuid.hashCode;


  static TratamientoProgramadoEntity fromJson(Map<String, Object> json){
    return TratamientoProgramadoEntity(
      json['uuid'] as String,
      json['detalle'] as List<dynamic>,
      json['fecha'] as DateTime,
      json['pendiente'] as bool,
      json['tropaUuid'] as String
    );
  }

  static TratamientoProgramadoEntity fromSnapshot(DocumentSnapshot snap){
    return TratamientoProgramadoEntity(
        snap.documentID,
        snap.data['detalle'],
        snap.data['fecha'] != null
            ? (snap.data['fecha'] is int ||
            snap.data['fecha'] is double)
            ? DateTime.fromMillisecondsSinceEpoch(
            snap.data['fecha'].round().toInt())
            : snap.data['fecha'].toDate()
            : null,
        snap.data['pendiente'],
        snap.data['tropaUuid']
    );
  }

  Map<String, Object> toDocument(){
    return {
      'detalle': this.detalle,
      'fecha': this.fecha,
      'pendiente': this.pendiente,
      'rodeo': this.tropaUuid
    };
  }


}