

import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:firebase_repository/firebase_repository.dart';
import 'package:firebase_repository/src/models/movrodeo.dart';
import 'package:firebase_repository/src/movrodeos_repository.dart';
import 'package:flutter/cupertino.dart';

class FirebaseMovrodeosRepository implements MovrodeosRepository{
  CollectionReference movroderosCollection;
  String empresaId;

  FirebaseMovrodeosRepository({@required String empresaId}){
    this.movroderosCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection('movrodeos');
  }


  @override
  Future<void> addNewMovrodeo(Movrodeo movrodeo) {
    return movroderosCollection.add(movrodeo.toEntity().toDocument());
  }

  @override
  Future<void> deleteMovrodeo(Movrodeo movrodeo) {
    return movroderosCollection.document(movrodeo.uuid).delete();
  }

  @override
  Stream<List<Movrodeo>> movrodeos() {
    return movroderosCollection.snapshots().map((snapshot) {
      print(snapshot);
      return snapshot.documents
          .map((doc) => Movrodeo.fromEntity(MovrodeoEntity.fromSnapshot(doc))).toList();
    });
  }

  @override
  Future<void> updateMovrodeo(Movrodeo movrodeo) {
    return movroderosCollection
        .document(movrodeo.uuid)
        .updateData(movrodeo.toEntity().toDocument());
  }
}