
import 'package:firebase_repository/firebase_repository.dart';
import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:firebase_repository/src/models/tratamiento.dart';
import 'package:firebase_repository/src/tratamientos_repository.dart';

class FirebaseTratamientosRepository implements TratamientosRepository{
  CollectionReference tratamientoCollection;
  String empresaId;

  FirebaseTratamientosRepository({@required String empresaId}){
    this.tratamientoCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection('tratamientos');
  }

  @override
  Future<void> addNewTratamiento(Tratamiento tratamiento) {
    return tratamientoCollection.add(tratamiento.toEntity().toDocument());
  }

  @override
  Future<void> deleteTratamiento(Tratamiento tratamiento) {
   return tratamientoCollection.document(tratamiento.uuid).delete();
  }

  @override
  Stream<List<Tratamiento>> tratamientos() {
    return tratamientoCollection.snapshots().map((snapshot){
      print(snapshot);
      return snapshot.documents
          .map((doc) => Tratamiento.fromEntity(TratamientoEntity.fromSnapshot(doc))).toList();
    });
  }

  @override
  Future<void> updateTratamiento(Tratamiento tratamiento) {
    return tratamientoCollection
        .document(tratamiento.uuid)
        .updateData(tratamiento.toEntity().toDocument());
  }
}