import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class Corral {
  final String uuid;
  final String nombre;
  final String mixerUuid;
  final bool activo;

  Corral({this.uuid, this.nombre, this.mixerUuid, this.activo});

  @override
  String toString() {
    return 'Corral{uuid: $uuid, nombre: $nombre, mixerUuid: $mixerUuid, activo: $activo}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Corral &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          nombre == other.nombre &&
          mixerUuid == other.mixerUuid &&
          activo == other.activo;

  @override
  int get hashCode =>
      uuid.hashCode ^ nombre.hashCode ^ mixerUuid.hashCode ^ activo.hashCode;

  Corral copyWith({String uuid, String nombre, String mixerUuid, bool activo}) {
    return Corral(
        uuid: uuid ?? this.uuid,
        nombre: nombre ?? this.nombre,
        mixerUuid: mixerUuid ?? this.mixerUuid,
        activo: activo ?? this.activo);
  }

  CorralEntity toEntity() {
    return CorralEntity(uuid, nombre, mixerUuid,activo);
  }

  static Corral fromEntity(CorralEntity entity) {
    return Corral(
        uuid: entity.uuid, nombre: entity.nombre, mixerUuid: entity.mixerUuid,activo: entity.activo);
  }
}
