import 'package:firebase_repository/firebase_repository.dart';

class Descarga {
  final String uuid;
  final double agua;
  final int cabezas;
  final double calcio;
  final String categoriaUuid;
  final String corralUuid;
  final double costo;
  final String dietaUuid;
  final double fdn;
  final DateTime fecha;
  final double fosforo;
  final String cargaUuid;
  final List<dynamic> ingredientes;
  final double kilos;
  final double materiaSeca;
  final double mcal;
  final int meta;
  final double porcentaje;
  final double prot;
  final int remanenteFuturo;
  final int remanenteHoy;
  final String tropaUuid;
  final double talcual;
  final String usuarioUuid;

  Descarga(
      {this.uuid,
      this.agua,
      this.cabezas,
      this.calcio,
      this.categoriaUuid,
      this.corralUuid,
      this.costo,
      this.dietaUuid,
      this.fdn,
      this.fecha,
      this.fosforo,
      this.cargaUuid,
      this.ingredientes,
      this.kilos,
      this.materiaSeca,
      this.mcal,
      this.meta,
      this.porcentaje,
      this.prot,
      this.remanenteFuturo,
      this.remanenteHoy,
      this.tropaUuid,
      this.talcual,
      this.usuarioUuid});

  Descarga copyWith({
    String uuid,
    double agua,
    int cabezas,
    double calcio,
    String categoriaUuid,
    String corralUuid,
    double costo,
    String dietaUuid,
    double fdn,
    DateTime fecha,
    double fosforo,
    String cargaUuid,
    List<dynamic> ingredientes,
    double kilos,
    double materiaSeca,
    double mcal,
    int meta,
    double porcentaje,
    double prot,
    int remanenteFuturo,
    int remanenteHoy,
    String tropaUuid,
    double talcual,
    String usuarioUuid,
  }) {
    return Descarga(
        uuid: uuid ?? this.uuid,
        agua: agua ?? this.agua,
        cabezas: cabezas ?? this.cabezas,
        calcio: calcio ?? this.calcio,
        categoriaUuid: categoriaUuid ?? this.categoriaUuid,
        corralUuid: corralUuid ?? this.corralUuid,
        costo: costo ?? this.costo,
        dietaUuid: dietaUuid ?? this.dietaUuid,
        fdn: fdn ?? this.fdn,
        fecha: fecha ?? this.fecha,
        fosforo: fosforo ?? this.fosforo,
        cargaUuid: cargaUuid ?? this.cargaUuid,
        ingredientes: ingredientes ?? this.ingredientes,
        kilos: kilos ?? this.kilos,
        materiaSeca: materiaSeca ?? this.materiaSeca,
        meta: meta ?? this.meta,
        mcal: mcal ?? this.mcal,
        porcentaje: porcentaje ?? this.porcentaje,
        prot: prot ?? this.prot,
        remanenteFuturo: remanenteFuturo ?? this.remanenteFuturo,
        remanenteHoy: remanenteHoy ?? this.remanenteHoy,
        tropaUuid: tropaUuid ?? this.tropaUuid,
        talcual: talcual ?? this.talcual,
        usuarioUuid: usuarioUuid ?? this.usuarioUuid);
  }

  @override
  String toString() {
    return 'Descarga{uuid: $uuid, agua: $agua, cabezas: $cabezas, calcio: $calcio, categoriaUuid: $categoriaUuid, corralUuid: $corralUuid, costo: $costo, dietaUuid: $dietaUuid, fdn: $fdn, fecha: $fecha, fosforo: $fosforo, cargaUuid: $cargaUuid, ingredientes: $ingredientes, kilos: $kilos, materiaSeca: $materiaSeca, mcal: $mcal, meta: $meta, porcentaje: $porcentaje, prot: $prot, remanenteFuturo: $remanenteFuturo, remanenteHoy: $remanenteHoy, tropaUuid: $tropaUuid, talcual: $talcual, usuarioUuid: $usuarioUuid}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Descarga &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              agua == other.agua &&
              cabezas == other.cabezas &&
              calcio == other.calcio &&
              categoriaUuid == other.categoriaUuid &&
              corralUuid == other.corralUuid &&
              costo == other.costo &&
              dietaUuid == other.dietaUuid &&
              fdn == other.fdn &&
              fecha == other.fecha &&
              fosforo == other.fosforo &&
              cargaUuid == other.cargaUuid &&
              ingredientes == other.ingredientes &&
              kilos == other.kilos &&
              materiaSeca == other.materiaSeca &&
              mcal == other.mcal &&
              meta == other.meta &&
              porcentaje == other.porcentaje &&
              prot == other.prot &&
              remanenteFuturo == other.remanenteFuturo &&
              remanenteHoy == other.remanenteHoy &&
              tropaUuid == other.tropaUuid &&
              talcual == other.talcual &&
              usuarioUuid == other.usuarioUuid;

  @override
  int get hashCode =>
      uuid.hashCode ^
      agua.hashCode ^
      cabezas.hashCode ^
      calcio.hashCode ^
      categoriaUuid.hashCode ^
      corralUuid.hashCode ^
      costo.hashCode ^
      dietaUuid.hashCode ^
      fdn.hashCode ^
      fecha.hashCode ^
      fosforo.hashCode ^
      cargaUuid.hashCode ^
      ingredientes.hashCode ^
      kilos.hashCode ^
      materiaSeca.hashCode ^
      mcal.hashCode ^
      meta.hashCode ^
      porcentaje.hashCode ^
      prot.hashCode ^
      remanenteFuturo.hashCode ^
      remanenteHoy.hashCode ^
      tropaUuid.hashCode ^
      talcual.hashCode ^
      usuarioUuid.hashCode;

  DescargaEntity toEntity(){
    return DescargaEntity(
      uuid,
      agua,
      cabezas,
      calcio,
      categoriaUuid,
      corralUuid,
      costo,
      dietaUuid,
      fdn,
      fecha,
      fosforo,
      cargaUuid,
      ingredientes,
      kilos,
      materiaSeca,
      mcal,
      meta,
      porcentaje,
      prot,
      remanenteFuturo,
      remanenteHoy,
      tropaUuid,
      talcual,
      usuarioUuid
    );
  }

  static Descarga fromEntity(DescargaEntity entity){
   return Descarga(
     uuid: entity.uuid,
     agua: entity.agua,
     cabezas: entity.cabezas,
     calcio: entity.calcio,
     categoriaUuid: entity.categoriaUuid,
     corralUuid: entity.corralUuid,
     costo: entity.costo,
     dietaUuid: entity.dietaUuid,
     fdn: entity.fdn,
     fecha: entity.fecha,
     fosforo: entity.fosforo,
     cargaUuid: entity.cargaUuid,
     ingredientes: entity.ingredientes,
     kilos: entity.kilos,
     materiaSeca: entity.materiaSeca,
     mcal: entity.mcal,
     meta: entity.meta,
     porcentaje: entity.porcentaje,
     prot: entity.prot,
     remanenteFuturo: entity.remanenteFuturo,
     remanenteHoy: entity.remanenteHoy,
     tropaUuid: entity.tropaUuid,
     talcual: entity.talcual,
     usuarioUuid: entity.usuarioUuid

   );
  }
}
