import 'package:firebase_repository/firebase_repository.dart';
import 'package:flutter/cupertino.dart';

@immutable
class Tratamiento {
  final String uuid;
  final int cabezas;
  final List<dynamic> detalle;
  final DateTime fecha;
  final String tropaUuid;

  Tratamiento(
      {this.uuid, this.cabezas, this.detalle, this.fecha, this.tropaUuid});

  Tratamiento copyWith(
      {String uuid,
      int cabezas,
      List<dynamic> detalle,
      DateTime fecha,
      String tropaUuid}) {
    return Tratamiento(
        uuid: uuid ?? this.uuid,
        cabezas: cabezas ?? this.cabezas,
        detalle: detalle ?? this.detalle,
        fecha: fecha ?? this.detalle,
        tropaUuid: tropaUuid ?? this.tropaUuid);
  }

  @override
  String toString() {
    return 'Tratamiento{uuid: $uuid, cabezas: $cabezas, detalle: $detalle, fecha: $fecha, tropaUuid: $tropaUuid}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Tratamiento &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          cabezas == other.cabezas &&
          detalle == other.detalle &&
          fecha == other.fecha &&
          tropaUuid == other.tropaUuid;

  @override
  int get hashCode =>
      uuid.hashCode ^
      cabezas.hashCode ^
      detalle.hashCode ^
      fecha.hashCode ^
      tropaUuid.hashCode;

  TratamientoEntity toEntity( ) {
    return TratamientoEntity(uuid, cabezas, detalle, fecha, tropaUuid);
  }

  static Tratamiento fromEntity(TratamientoEntity entity) {
    return Tratamiento(
        uuid: entity.uuid,
        cabezas: entity.cabezas,
        detalle: entity.detalle,
        fecha: entity.fecha,
        tropaUuid: entity.tropaUuid);
  }
}
