import 'package:firebase_repository/src/entities/entities.dart';
import 'package:meta/meta.dart';

@immutable
class TratamientoProgramado {
  final String uuid;
  final List<dynamic> detalle;
  final DateTime fecha;
  final bool pendiente;
  final String tropaUuid;

  TratamientoProgramado(
      {this.uuid, this.detalle, this.fecha, this.pendiente, this.tropaUuid});

  TratamientoProgramado copyWith(
      {String uuid,
      List<dynamic> detalle,
      DateTime fecha,
      bool pendiente,
      String tropaUuid}) {
    return TratamientoProgramado(
        uuid: uuid ?? this.uuid,
        detalle: detalle ?? this.detalle,
        fecha: fecha ?? this.fecha,
        pendiente: pendiente ?? this.pendiente,
        tropaUuid: tropaUuid ?? this.tropaUuid);
  }

  @override
  String toString() {
    return 'TratamientoProgramado{uuid: $uuid, detalle: $detalle, fecha: $fecha, pendiente: $pendiente, tropaUuid: $tropaUuid}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is TratamientoProgramado &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              detalle == other.detalle &&
              fecha == other.fecha &&
              pendiente == other.pendiente &&
              tropaUuid == other.tropaUuid;

  @override
  int get hashCode =>
      uuid.hashCode ^
      detalle.hashCode ^
      fecha.hashCode ^
      pendiente.hashCode ^
      tropaUuid.hashCode;

  TratamientoProgramadoEntity toEntity(){
    return TratamientoProgramadoEntity(uuid, detalle, fecha, pendiente, tropaUuid);
  }

  static TratamientoProgramado fromEntity(TratamientoProgramadoEntity entity){
    return TratamientoProgramado(
      uuid: entity.uuid,
      detalle: entity.detalle,
      fecha: entity.fecha,
      pendiente: entity.pendiente,
      tropaUuid: entity.tropaUuid
    );
  }


}
